/*----------------------------------------------------------------------*
    MainMenus.c version 3.0 -  Copyright 1991 Jaba Development

    Author : Jan van den Baard
    Purpose: Menu editind menus strips.
 *----------------------------------------------------------------------*/
struct IntuiText MainItemText[] = {
  0,1,JAM2,1,1,NULL,(UBYTE *)"Add a menu",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Edit menu          ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Delete menu        ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Insert menu before ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Edit items for     ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Test Menus",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Gadgets Menu",NULL };

struct MenuItem MainItem[] = {
  &MainItem[1],0,0,164,10,ITEMENABLED+HIGHCOMP+ITEMTEXT+COMMSEQ,0,(APTR)&MainItemText[0],NULL,65,NULL,0,
  &MainItem[2],0,10,164,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&MainItemText[1],NULL,0,NULL,0,
  &MainItem[3],0,20,164,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&MainItemText[2],NULL,0,NULL,0,
  &MainItem[4],0,30,164,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&MainItemText[3],NULL,0,NULL,0,
  &MainItem[5],0,40,164,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&MainItemText[4],NULL,0,NULL,0,
  &MainItem[6],0,50,164,10,ITEMENABLED+HIGHCOMP+ITEMTEXT+COMMSEQ,0,(APTR)&MainItemText[5],NULL,84,NULL,0,
  NULL,0,60,164,10,ITEMENABLED+HIGHCOMP+ITEMTEXT+COMMSEQ,0,(APTR)&MainItemText[6],NULL,71,NULL,0 };

struct Menu MainMenuStrip[] = {
  NULL,0,0,68,10,MENUENABLED,(BYTE *)"Menus",&MainItem[0],0,0,0,0 };

struct IntuiText ItemText[] = {
  0,1,JAM2,1,1,NULL,(UBYTE *)"Add item",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Edit item            ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Delete item          ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Insert item before   ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Edit subitems for    ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Main menu",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Set MutualExclude",NULL };

struct MenuItem TheItem[] = {
  &TheItem[1],0,0,180,10,ITEMENABLED+HIGHCOMP+COMMSEQ+ITEMTEXT,0,(APTR)&ItemText[0],NULL,65,NULL,0,
  &TheItem[2],0,10,180,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&ItemText[1],NULL,0,NULL,0,
  &TheItem[3],0,20,180,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&ItemText[2],NULL,0,NULL,0,
  &TheItem[4],0,30,180,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&ItemText[3],NULL,0,NULL,0,
  &TheItem[5],0,40,180,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&ItemText[4],NULL,0,NULL,0,
  &TheItem[6],0,50,180,10,ITEMENABLED+HIGHCOMP+ITEMTEXT+COMMSEQ,0,(APTR)&ItemText[5],NULL,77,NULL,0,
  NULL,0,60,180,10,ITEMENABLED+HIGHCOMP+ITEMTEXT+COMMSEQ,0,(APTR)&ItemText[6],NULL,69,NULL,0 };

struct Menu ItemMenuStrip[] = {
  NULL,0,0,52,10,MENUENABLED,(BYTE *)"Items",&TheItem[0],0,0,0,0 };

struct IntuiText SubText[] = {
  0,1,JAM2,1,1,NULL,(UBYTE *)"Add subitem",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Edit subitem          ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Delete subitem        ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Insert subitem before ",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Item menu",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Main menu",NULL,
  0,1,JAM2,1,1,NULL,(UBYTE *)"Set MutualExclude",NULL };

struct MenuItem SubItem[] = {
  &SubItem[1],0,0,188,10,ITEMENABLED+HIGHCOMP+COMMSEQ+ITEMTEXT,0,(APTR)&SubText[0],NULL,65,NULL,0,
  &SubItem[2],0,10,188,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&SubText[1],NULL,0,NULL,0,
  &SubItem[3],0,20,188,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&SubText[2],NULL,0,NULL,0,
  &SubItem[4],0,30,188,10,ITEMENABLED+HIGHCOMP+ITEMTEXT,0,(APTR)&SubText[3],NULL,0,NULL,0,
  &SubItem[5],0,40,188,10,ITEMENABLED+HIGHCOMP+ITEMTEXT+COMMSEQ,0,(APTR)&SubText[4],NULL,73,NULL,0,
  &SubItem[6],0,50,188,10,ITEMENABLED+HIGHCOMP+ITEMTEXT+COMMSEQ,0,(APTR)&SubText[5],NULL,77,NULL,0,
  NULL,0,60,180,10,ITEMENABLED+HIGHCOMP+ITEMTEXT+COMMSEQ,0,(APTR)&SubText[6],NULL,69,NULL,0 };


struct Menu SubMenuStrip[] = {
  NULL,0,0,76,10,MENUENABLED,(BYTE *)"SubItems",&SubItem[0],0,0,0,0 };
